#!/bin/sh

dir="/var/log/"
exec="kylin-sourceinfo-server"
tmpDir=$dir$exec"/watch_dog_tmp"
clearDir=$tmpDir"/*"
logFile=$dir$exec"/watch_dog"
noServer="true"
errorLog="\n=========================================================================="

while true
do 
	#等待1秒
	sleep 1s
	#调用接口
	wget -q --timeout=10 -P$tmpDir localhost:59546/client/000/88888888
	#判断是否成功请求（判断目录中是否存在文件）
	if [ "`ls -A $tmpDir`" = "" ]; then
		#如果进程已经被杀死，则等待下次请求成功再继续
		if [ $noServer = "true" ]; then
			#echo "未找到服务"
			continue
		fi
		#不成功则打印日志并结束进程
		var=$(pidof $exec)
		if [ $var ]; then
			#分割线
			echo $errorLog >> $logFile
			#时间
			echo "\n[当前时间]" >> $logFile
			date "+%Y-%m-%d %H:%M:%S" >> $logFile
			#top结果
			echo "\n[top结果]" >> $logFile
			top -b -p $var -n 1 | head -8 >> $logFile
			#当前打开文件数量
			echo "\n[打开文件]" >> $logFile
			ls -l /proc/$var/fd/ | wc -l >> $logFile
			#分割线
			echo $errorLog >> $logFile
			#杀死服务器进程
			killall $exec
		fi
		noServer="true"
	else
		#成功则删除上一次的文件
		#echo "服务正常"
		noServer="false"
		rm $clearDir
	fi
done
