/*
 Navicat Premium Data Transfer

 Source Server         : YYF
 Source Server Type    : MySQL
 Source Server Version : 50725
 Source Host           : bdm721903566.my3w.com:3306
 Source Schema         : bdm721903566_db

 Target Server Type    : MySQL
 Target Server Version : 50725
 File Encoding         : 65001

 Date: 08/01/2021 19:28:42
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for gtable
-- ----------------------------
DROP TABLE IF EXISTS `gtable`;
CREATE TABLE `gtable` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `table-name` varchar(255) NOT NULL,
  `machine-information` varchar(255) NOT NULL,
  `serial-number` varchar(255) NOT NULL,
  `source-type` varchar(255) NOT NULL DEFAULT '',
  `requests` bigint(20) unsigned NOT NULL,
  `updatetime` varchar(255) NOT NULL DEFAULT '',
  `creattime` varchar(255) NOT NULL DEFAULT '',
  `isactive` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(0) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `m_uuid` (`machine-information`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of gtable
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for sinfo
-- ----------------------------
DROP TABLE IF EXISTS `sinfo`;
CREATE TABLE `sinfo` (
  `table-name` varchar(180) NOT NULL DEFAULT '',
  `inrelease-md5` varchar(255) DEFAULT NULL,
  `source-information` text NOT NULL,
  `source-back1` varchar(255) DEFAULT '',
  `source-back2` varchar(255) DEFAULT '',
  `source-back3` varchar(255) DEFAULT '',
  `source-back4` varchar(255) DEFAULT '',
  `source-back5` varchar(255) DEFAULT '',
  `push-list` text,
  `optional-list` text,
  `grayscale-md5` varchar(255) DEFAULT NULL,
  `grayscale-information` text NOT NULL,
  `grayscale-back1` varchar(255) DEFAULT '',
  `grayscale-back2` varchar(255) DEFAULT '',
  `grayscale-back3` varchar(255) DEFAULT '',
  `grayscale-back4` varchar(255) DEFAULT '',
  `grayscale-back5` varchar(255) DEFAULT '',
  `grayscale-key` int(255) NOT NULL,
  `updatetime` varchar(255) NOT NULL DEFAULT '',
  `source-id` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`table-name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of sinfo
-- ----------------------------
BEGIN;
INSERT INTO `sinfo` VALUES ('default', '', 'deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main restricted universe multiverse\ndeb http://archive.kylinos.cn/kylin/partner 10.1 main', '', '', '', '', '', 'kylin-installer kylin-recorder kylin-scanner kylin-screenshot kylin-user-guide kylin-video ukui-biometric-manager', 'kylin-activation', '', 'deb http://archive.kylinos.cn/kylin/KYLIN-ALL 10.1 main restricted universe multiverse\ndeb http://archive.kylinos.cn/kylin/partner 10.1 main', '', '', '', '', '', 0, '1609587708', '$2$1$', '默认主源');
COMMIT;

-- ----------------------------
-- Table structure for sources
-- ----------------------------
DROP TABLE IF EXISTS `sources`;
CREATE TABLE `sources` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `keyword` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `source` (`keyword`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of sources
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for ssmap
-- ----------------------------
DROP TABLE IF EXISTS `ssmap`;
CREATE TABLE `ssmap` (
  `serial-number` varchar(255) NOT NULL,
  `table-name` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) DEFAULT '',
  PRIMARY KEY (`serial-number`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of ssmap
-- ----------------------------
BEGIN;
INSERT INTO `ssmap` VALUES ('88888888', 'default', '默认');
COMMIT;

-- ----------------------------
-- Table structure for user
-- ----------------------------
DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL DEFAULT '',
  `password` varchar(255) NOT NULL DEFAULT '',
  `salt` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of user
-- ----------------------------
BEGIN;
INSERT INTO `user` VALUES (1, 'admin', '0517255859d955e86465e8abf5d497e7', '1nqzpus6i');
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
